Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIArrowSplitter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIArrowSplitter.cpp	(revision 71394)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIArrowSplitter.cpp	(revision 71395)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2017 Oracle Corporation
+ * Copyright (C) 2006-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -22,12 +22,12 @@
 /* Qt includes: */
 # include <QApplication>
+# include <QHBoxLayout>
 # include <QStyle>
-# include <QHBoxLayout>
 # include <QTextEdit>
 
 /* GUI includes: */
 # include "QIArrowSplitter.h"
+# include "QIArrowButtonPress.h"
 # include "QIArrowButtonSwitch.h"
-# include "QIArrowButtonPress.h"
 # include "UIDesktopWidgetWatchdog.h"
 # include "UIIconPool.h"
@@ -37,5 +37,4 @@
 
 #endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
-
 
 
@@ -50,5 +49,5 @@
 public:
 
-    /** Constructor, passes @a pParent to the QTextEdit constructor. */
+    /** Constructs details-browser passing @a pParent to the base-class. */
     QIDetailsBrowser(QWidget *pParent = 0);
 
@@ -61,4 +60,9 @@
     void updateScrollBars();
 };
+
+
+/*********************************************************************************************************************************
+*   Class QIDetailsBrowser implementation.                                                                                       *
+*********************************************************************************************************************************/
 
 QIDetailsBrowser::QIDetailsBrowser(QWidget *pParent /* = 0 */)
@@ -117,4 +121,8 @@
 }
 
+
+/*********************************************************************************************************************************
+*   Class QIArrowSplitter implementation.                                                                                        *
+*********************************************************************************************************************************/
 
 QIArrowSplitter::QIArrowSplitter(QWidget *pParent /* = 0 */)
@@ -224,4 +232,10 @@
     /* Increase details-list index: */
     ++m_iDetailsIndex;
+    /* Update details: */
+    updateDetails();
+}
+
+void QIArrowSplitter::retranslateUi()
+{
     /* Update details: */
     updateDetails();
@@ -313,10 +327,4 @@
 }
 
-void QIArrowSplitter::retranslateUi()
-{
-    /* Update details: */
-    updateDetails();
-}
-
 void QIArrowSplitter::updateDetails()
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIArrowSplitter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIArrowSplitter.h	(revision 71394)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIArrowSplitter.h	(revision 71395)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2017 Oracle Corporation
+ * Copyright (C) 2006-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -43,10 +43,10 @@
 signals:
 
-    /** Notifies listeners about size-hint change: */
+    /** Notifies listeners about size-hint change. */
     void sigSizeHintChange();
 
 public:
 
-    /** Constructor, passes @a pParent to the QWidget constructor. */
+    /** Constructs arrow splitter passing @a pParent to the base-class. */
     QIArrowSplitter(QWidget *pParent = 0);
 
@@ -77,32 +77,35 @@
     void sltSwitchDetailsPageNext();
 
+protected:
+
+    /** Handles translation event. */
+    virtual void retranslateUi() /* override */;
+
 private:
 
-    /** Prepare routine. */
+    /** Prepares all. */
     void prepare();
-
-    /** Retranslation routine. */
-    void retranslateUi();
 
     /** Updates details. */
     void updateDetails();
 
-    /** Holds the main-layout. */
+    /** Holds the main-layout instance. */
     QVBoxLayout *m_pMainLayout;
 
-    /** Holds the switch-button. */
+    /** Holds the switch-button instance. */
     QIArrowButtonSwitch *m_pSwitchButton;
-    /** Holds the back-button. */
-    QIArrowButtonPress *m_pBackButton;
-    /** Holds the next-button. */
-    QIArrowButtonPress *m_pNextButton;
+    /** Holds the back-button instance. */
+    QIArrowButtonPress  *m_pBackButton;
+    /** Holds the next-button instance. */
+    QIArrowButtonPress  *m_pNextButton;
 
     /** Holds the details-browser. */
     QIDetailsBrowser *m_pDetailsBrowser;
     /** Holds details-list. */
-    QStringPairList m_details;
+    QStringPairList   m_details;
     /** Holds details-list index. */
-    int m_iDetailsIndex;
+    int               m_iDetailsIndex;
 };
 
 #endif /* !___QIArrowSplitter_h___ */
+