Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.cpp	(revision 71453)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.cpp	(revision 71454)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2017 Oracle Corporation
+ * Copyright (C) 2010-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -21,10 +21,10 @@
 
 /* Qt includes: */
+# include <QMutex>
 # include <QThread>
-# include <QMutex>
 
 /* GUI includes: */
+# include "VBoxGlobal.h"
 # include "UIMainEventListener.h"
-# include "VBoxGlobal.h"
 
 /* COM includes: */
@@ -40,14 +40,14 @@
 # include "CGuestProcessIOEvent.h"
 # include "CGuestProcessRegisteredEvent.h"
+# include "CGuestProcessStateChangedEvent.h"
 # include "CGuestSessionRegisteredEvent.h"
-# include "CGuestProcessStateChangedEvent.h"
 # include "CGuestSessionStateChangedEvent.h"
 # include "CKeyboardLedsChangedEvent.h"
+# include "CMachineDataChangedEvent.h"
 # include "CMachineStateChangedEvent.h"
-# include "CMachineDataChangedEvent.h"
 # include "CMachineRegisteredEvent.h"
+# include "CMediumChangedEvent.h"
+# include "CMouseCapabilityChangedEvent.h"
 # include "CMousePointerShapeChangedEvent.h"
-# include "CMouseCapabilityChangedEvent.h"
-# include "CMediumChangedEvent.h"
 # include "CNetworkAdapterChangedEvent.h"
 # include "CProgressPercentageChangedEvent.h"
@@ -56,8 +56,8 @@
 # include "CSessionStateChangedEvent.h"
 # include "CShowWindowEvent.h"
+# include "CSnapshotChangedEvent.h"
+# include "CSnapshotDeletedEvent.h"
+# include "CSnapshotRestoredEvent.h"
 # include "CSnapshotTakenEvent.h"
-# include "CSnapshotDeletedEvent.h"
-# include "CSnapshotChangedEvent.h"
-# include "CSnapshotRestoredEvent.h"
 # include "CStateChangedEvent.h"
 # include "CStorageDeviceChangedEvent.h"
@@ -78,6 +78,6 @@
 public:
 
-    /** Constructs Main events listener thread redirecting events from @a source to @a listener. */
-    UIMainEventListeningThread(const CEventSource &source, const CEventListener &listener);
+    /** Constructs Main events listener thread redirecting events from @a comSource to @a comListener. */
+    UIMainEventListeningThread(const CEventSource &comSource, const CEventListener &comListener);
     /** Destructs Main events listener thread. */
     ~UIMainEventListeningThread();
@@ -96,7 +96,7 @@
 
     /** Holds the Main event source reference. */
-    CEventSource m_source;
+    CEventSource m_comSource;
     /** Holds the Main event listener reference. */
-    CEventListener m_listener;
+    CEventListener m_comListener;
 
     /** Holds the mutex instance which protects thread access. */
@@ -111,7 +111,7 @@
 *********************************************************************************************************************************/
 
-UIMainEventListeningThread::UIMainEventListeningThread(const CEventSource &source, const CEventListener &listener)
-    : m_source(source)
-    , m_listener(listener)
+UIMainEventListeningThread::UIMainEventListeningThread(const CEventSource &comSource, const CEventListener &comListener)
+    : m_comSource(comSource)
+    , m_comListener(comListener)
     , m_fShutdown(false)
 {
@@ -133,7 +133,7 @@
 
     /* Copy source wrapper to this thread: */
-    CEventSource source = m_source;
+    CEventSource comSource = m_comSource;
     /* Copy listener wrapper to this thread: */
-    CEventListener listener = m_listener;
+    CEventListener comListener = m_comListener;
 
     /* While we are not in shutdown: */
@@ -141,11 +141,11 @@
     {
         /* Fetch the event from the queue: */
-        CEvent event = source.GetEvent(listener, 500);
-        if (!event.isNull())
+        CEvent comEvent = comSource.GetEvent(comListener, 500);
+        if (!comEvent.isNull())
         {
             /* Process the event and tell the listener: */
-            listener.HandleEvent(event);
-            if (event.GetWaitable())
-                source.EventProcessed(listener, event);
+            comListener.HandleEvent(comEvent);
+            if (comEvent.GetWaitable())
+                comSource.EventProcessed(comListener, comEvent);
         }
     }
@@ -189,12 +189,12 @@
 }
 
-void UIMainEventListener::registerSource(const CEventSource &source, const CEventListener &listener)
+void UIMainEventListener::registerSource(const CEventSource &comSource, const CEventListener &comListener)
 {
     /* Make sure source and listener are valid: */
-    AssertReturnVoid(!source.isNull());
-    AssertReturnVoid(!listener.isNull());
+    AssertReturnVoid(!comSource.isNull());
+    AssertReturnVoid(!comListener.isNull());
 
     /* Create thread for passed source: */
-    m_threads << new UIMainEventListeningThread(source, listener);
+    m_threads << new UIMainEventListeningThread(comSource, comListener);
     /* And start it: */
     m_threads.last()->start();
@@ -207,5 +207,5 @@
 }
 
-STDMETHODIMP UIMainEventListener::HandleEvent(VBoxEventType_T /* type */, IEvent *pEvent)
+STDMETHODIMP UIMainEventListener::HandleEvent(VBoxEventType_T, IEvent *pEvent)
 {
     /* Try to acquire COM cleanup protection token first: */
@@ -213,12 +213,12 @@
         return S_OK;
 
-    CEvent event(pEvent);
-    //printf("Event received: %d\n", event.GetType());
-    switch (event.GetType())
+    CEvent comEvent(pEvent);
+    //printf("Event received: %d\n", comEvent.GetType());
+    switch (comEvent.GetType())
     {
         case KVBoxEventType_OnVBoxSVCAvailabilityChanged:
         {
-            CVBoxSVCAvailabilityChangedEvent es(pEvent);
-            emit sigVBoxSVCAvailabilityChange(es.GetAvailable());
+            CVBoxSVCAvailabilityChangedEvent comEventSpecific(pEvent);
+            emit sigVBoxSVCAvailabilityChange(comEventSpecific.GetAvailable());
             break;
         }
@@ -226,48 +226,48 @@
         case KVBoxEventType_OnMachineStateChanged:
         {
-            CMachineStateChangedEvent es(pEvent);
-            emit sigMachineStateChange(es.GetMachineId(), es.GetState());
+            CMachineStateChangedEvent comEventSpecific(pEvent);
+            emit sigMachineStateChange(comEventSpecific.GetMachineId(), comEventSpecific.GetState());
             break;
         }
         case KVBoxEventType_OnMachineDataChanged:
         {
-            CMachineDataChangedEvent es(pEvent);
-            emit sigMachineDataChange(es.GetMachineId());
+            CMachineDataChangedEvent comEventSpecific(pEvent);
+            emit sigMachineDataChange(comEventSpecific.GetMachineId());
             break;
         }
         case KVBoxEventType_OnMachineRegistered:
         {
-            CMachineRegisteredEvent es(pEvent);
-            emit sigMachineRegistered(es.GetMachineId(), es.GetRegistered());
+            CMachineRegisteredEvent comEventSpecific(pEvent);
+            emit sigMachineRegistered(comEventSpecific.GetMachineId(), comEventSpecific.GetRegistered());
             break;
         }
         case KVBoxEventType_OnSessionStateChanged:
         {
-            CSessionStateChangedEvent es(pEvent);
-            emit sigSessionStateChange(es.GetMachineId(), es.GetState());
+            CSessionStateChangedEvent comEventSpecific(pEvent);
+            emit sigSessionStateChange(comEventSpecific.GetMachineId(), comEventSpecific.GetState());
             break;
         }
         case KVBoxEventType_OnSnapshotTaken:
         {
-            CSnapshotTakenEvent es(pEvent);
-            emit sigSnapshotTake(es.GetMachineId(), es.GetSnapshotId());
+            CSnapshotTakenEvent comEventSpecific(pEvent);
+            emit sigSnapshotTake(comEventSpecific.GetMachineId(), comEventSpecific.GetSnapshotId());
             break;
         }
         case KVBoxEventType_OnSnapshotDeleted:
         {
-            CSnapshotDeletedEvent es(pEvent);
-            emit sigSnapshotDelete(es.GetMachineId(), es.GetSnapshotId());
+            CSnapshotDeletedEvent comEventSpecific(pEvent);
+            emit sigSnapshotDelete(comEventSpecific.GetMachineId(), comEventSpecific.GetSnapshotId());
             break;
         }
         case KVBoxEventType_OnSnapshotChanged:
         {
-            CSnapshotChangedEvent es(pEvent);
-            emit sigSnapshotChange(es.GetMachineId(), es.GetSnapshotId());
+            CSnapshotChangedEvent comEventSpecific(pEvent);
+            emit sigSnapshotChange(comEventSpecific.GetMachineId(), comEventSpecific.GetSnapshotId());
             break;
         }
         case KVBoxEventType_OnSnapshotRestored:
         {
-            CSnapshotRestoredEvent es(pEvent);
-            emit sigSnapshotRestore(es.GetMachineId(), es.GetSnapshotId());
+            CSnapshotRestoredEvent comEventSpecific(pEvent);
+            emit sigSnapshotRestore(comEventSpecific.GetMachineId(), comEventSpecific.GetSnapshotId());
             break;
         }
@@ -277,17 +277,18 @@
         case KVBoxEventType_OnExtraDataCanChange:
         {
-            CExtraDataCanChangeEvent es(pEvent);
+            CExtraDataCanChangeEvent comEventSpecific(pEvent);
             /* Has to be done in place to give an answer: */
             bool fVeto = false;
             QString strReason;
-            emit sigExtraDataCanChange(es.GetMachineId(), es.GetKey(), es.GetValue(), fVeto, strReason);
+            emit sigExtraDataCanChange(comEventSpecific.GetMachineId(), comEventSpecific.GetKey(),
+                                       comEventSpecific.GetValue(), fVeto, strReason);
             if (fVeto)
-                es.AddVeto(strReason);
+                comEventSpecific.AddVeto(strReason);
             break;
         }
         case KVBoxEventType_OnExtraDataChanged:
         {
-            CExtraDataChangedEvent es(pEvent);
-            emit sigExtraDataChange(es.GetMachineId(), es.GetKey(), es.GetValue());
+            CExtraDataChangedEvent comEventSpecific(pEvent);
+            emit sigExtraDataChange(comEventSpecific.GetMachineId(), comEventSpecific.GetKey(), comEventSpecific.GetValue());
             break;
         }
@@ -295,30 +296,37 @@
         case KVBoxEventType_OnMousePointerShapeChanged:
         {
-            CMousePointerShapeChangedEvent es(pEvent);
-            emit sigMousePointerShapeChange(es.GetVisible(), es.GetAlpha(), QPoint(es.GetXhot(), es.GetYhot()), QSize(es.GetWidth(), es.GetHeight()), es.GetShape());
+            CMousePointerShapeChangedEvent comEventSpecific(pEvent);
+            emit sigMousePointerShapeChange(comEventSpecific.GetVisible(), comEventSpecific.GetAlpha(),
+                                            QPoint(comEventSpecific.GetXhot(), comEventSpecific.GetYhot()),
+                                            QSize(comEventSpecific.GetWidth(), comEventSpecific.GetHeight()),
+                                            comEventSpecific.GetShape());
             break;
         }
         case KVBoxEventType_OnMouseCapabilityChanged:
         {
-            CMouseCapabilityChangedEvent es(pEvent);
-            emit sigMouseCapabilityChange(es.GetSupportsAbsolute(), es.GetSupportsRelative(), es.GetSupportsMultiTouch(), es.GetNeedsHostCursor());
+            CMouseCapabilityChangedEvent comEventSpecific(pEvent);
+            emit sigMouseCapabilityChange(comEventSpecific.GetSupportsAbsolute(), comEventSpecific.GetSupportsRelative(),
+                                          comEventSpecific.GetSupportsMultiTouch(), comEventSpecific.GetNeedsHostCursor());
             break;
         }
         case KVBoxEventType_OnCursorPositionChanged:
         {
-            CCursorPositionChangedEvent es(pEvent);
-            emit sigCursorPositionChange(es.GetHasData(), (unsigned long)es.GetX(), (unsigned long)es.GetY());
+            CCursorPositionChangedEvent comEventSpecific(pEvent);
+            emit sigCursorPositionChange(comEventSpecific.GetHasData(),
+                                         (unsigned long)comEventSpecific.GetX(), (unsigned long)comEventSpecific.GetY());
             break;
         }
         case KVBoxEventType_OnKeyboardLedsChanged:
         {
-            CKeyboardLedsChangedEvent es(pEvent);
-            emit sigKeyboardLedsChangeEvent(es.GetNumLock(), es.GetCapsLock(), es.GetScrollLock());
+            CKeyboardLedsChangedEvent comEventSpecific(pEvent);
+            emit sigKeyboardLedsChangeEvent(comEventSpecific.GetNumLock(),
+                                            comEventSpecific.GetCapsLock(),
+                                            comEventSpecific.GetScrollLock());
             break;
         }
         case KVBoxEventType_OnStateChanged:
         {
-            CStateChangedEvent es(pEvent);
-            emit sigStateChange(es.GetState());
+            CStateChangedEvent comEventSpecific(pEvent);
+            emit sigStateChange(comEventSpecific.GetState());
             break;
         }
@@ -330,18 +338,20 @@
         case KVBoxEventType_OnNetworkAdapterChanged:
         {
-            CNetworkAdapterChangedEvent es(pEvent);
-            emit sigNetworkAdapterChange(es.GetNetworkAdapter());
+            CNetworkAdapterChangedEvent comEventSpecific(pEvent);
+            emit sigNetworkAdapterChange(comEventSpecific.GetNetworkAdapter());
             break;
         }
         case KVBoxEventType_OnStorageDeviceChanged:
         {
-            CStorageDeviceChangedEvent es(pEvent);
-            emit sigStorageDeviceChange(es.GetStorageDevice(), es.GetRemoved(), es.GetSilent());
+            CStorageDeviceChangedEvent comEventSpecific(pEvent);
+            emit sigStorageDeviceChange(comEventSpecific.GetStorageDevice(),
+                                        comEventSpecific.GetRemoved(),
+                                        comEventSpecific.GetSilent());
             break;
         }
         case KVBoxEventType_OnMediumChanged:
         {
-            CMediumChangedEvent es(pEvent);
-            emit sigMediumChange(es.GetMediumAttachment());
+            CMediumChangedEvent comEventSpecific(pEvent);
+            emit sigMediumChange(comEventSpecific.GetMediumAttachment());
             break;
         }
@@ -364,6 +374,8 @@
         case KVBoxEventType_OnUSBDeviceStateChanged:
         {
-            CUSBDeviceStateChangedEvent es(pEvent);
-            emit sigUSBDeviceStateChange(es.GetDevice(), es.GetAttached(), es.GetError());
+            CUSBDeviceStateChangedEvent comEventSpecific(pEvent);
+            emit sigUSBDeviceStateChange(comEventSpecific.GetDevice(),
+                                         comEventSpecific.GetAttached(),
+                                         comEventSpecific.GetError());
             break;
         }
@@ -380,18 +392,19 @@
         case KVBoxEventType_OnGuestMonitorChanged:
         {
-            CGuestMonitorChangedEvent es(pEvent);
-            emit sigGuestMonitorChange(es.GetChangeType(), es.GetScreenId(),
-                                       QRect(es.GetOriginX(), es.GetOriginY(), es.GetWidth(), es.GetHeight()));
+            CGuestMonitorChangedEvent comEventSpecific(pEvent);
+            emit sigGuestMonitorChange(comEventSpecific.GetChangeType(), comEventSpecific.GetScreenId(),
+                                       QRect(comEventSpecific.GetOriginX(), comEventSpecific.GetOriginY(),
+                                             comEventSpecific.GetWidth(), comEventSpecific.GetHeight()));
             break;
         }
         case KVBoxEventType_OnRuntimeError:
         {
-            CRuntimeErrorEvent es(pEvent);
-            emit sigRuntimeError(es.GetFatal(), es.GetId(), es.GetMessage());
+            CRuntimeErrorEvent comEventSpecific(pEvent);
+            emit sigRuntimeError(comEventSpecific.GetFatal(), comEventSpecific.GetId(), comEventSpecific.GetMessage());
             break;
         }
         case KVBoxEventType_OnCanShowWindow:
         {
-            CCanShowWindowEvent es(pEvent);
+            CCanShowWindowEvent comEventSpecific(pEvent);
             /* Has to be done in place to give an answer: */
             bool fVeto = false;
@@ -399,18 +412,18 @@
             emit sigCanShowWindow(fVeto, strReason);
             if (fVeto)
-                es.AddVeto(strReason);
+                comEventSpecific.AddVeto(strReason);
             else
-                es.AddApproval(strReason);
+                comEventSpecific.AddApproval(strReason);
             break;
         }
         case KVBoxEventType_OnShowWindow:
         {
-            CShowWindowEvent es(pEvent);
+            CShowWindowEvent comEventSpecific(pEvent);
             /* Has to be done in place to give an answer: */
-            qint64 winId = es.GetWinId();
+            qint64 winId = comEventSpecific.GetWinId();
             if (winId != 0)
                 break; /* Already set by some listener. */
             emit sigShowWindow(winId);
-            es.SetWinId(winId);
+            comEventSpecific.SetWinId(winId);
             break;
         }
@@ -422,12 +435,12 @@
         case KVBoxEventType_OnProgressPercentageChanged:
         {
-            CProgressPercentageChangedEvent es(pEvent);
-            emit sigProgressPercentageChange(es.GetProgressId(), (int)es.GetPercent());
+            CProgressPercentageChangedEvent comEventSpecific(pEvent);
+            emit sigProgressPercentageChange(comEventSpecific.GetProgressId(), (int)comEventSpecific.GetPercent());
             break;
         }
         case KVBoxEventType_OnProgressTaskCompleted:
         {
-            CProgressTaskCompletedEvent es(pEvent);
-            emit sigProgressTaskComplete(es.GetProgressId());
+            CProgressTaskCompletedEvent comEventSpecific(pEvent);
+            emit sigProgressTaskComplete(comEventSpecific.GetProgressId());
             break;
         }
@@ -435,24 +448,24 @@
         {
 
-            CGuestSessionRegisteredEvent cEvent(pEvent);
-            if(cEvent.GetRegistered())
-                emit sigGuestSessionRegistered(cEvent.GetSession());
+            CGuestSessionRegisteredEvent comEventSpecific(pEvent);
+            if (comEventSpecific.GetRegistered())
+                emit sigGuestSessionRegistered(comEventSpecific.GetSession());
             else
-                emit sigGuestSessionUnregistered(cEvent.GetSession());
+                emit sigGuestSessionUnregistered(comEventSpecific.GetSession());
             break;
         }
         case KVBoxEventType_OnGuestProcessRegistered:
         {
-            CGuestProcessRegisteredEvent cEvent(pEvent);
-            if(cEvent.GetRegistered())
-                emit sigGuestProcessRegistered(cEvent.GetProcess());
+            CGuestProcessRegisteredEvent comEventSpecific(pEvent);
+            if (comEventSpecific.GetRegistered())
+                emit sigGuestProcessRegistered(comEventSpecific.GetProcess());
             else
-                emit sigGuestProcessUnregistered(cEvent.GetProcess());
+                emit sigGuestProcessUnregistered(comEventSpecific.GetProcess());
             break;
         }
         case KVBoxEventType_OnGuestSessionStateChanged:
         {
-            CGuestSessionStateChangedEvent cEvent(pEvent);
-            emit sigGuestSessionStatedChanged(cEvent);
+            CGuestSessionStateChangedEvent comEventSpecific(pEvent);
+            emit sigGuestSessionStatedChanged(comEventSpecific);
             break;
         }
@@ -464,7 +477,7 @@
         case KVBoxEventType_OnGuestProcessStateChanged:
         {
-            CGuestProcessStateChangedEvent cEvent(pEvent);
-            cEvent.GetError();
-            emit sigGuestProcessStateChanged(cEvent);
+            CGuestProcessStateChangedEvent comEventSpecific(pEvent);
+            comEventSpecific.GetError();
+            emit sigGuestProcessStateChanged(comEventSpecific);
             break;
         }
@@ -489,2 +502,3 @@
 
 #include "UIMainEventListener.moc"
+
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.h	(revision 71453)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.h	(revision 71454)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2017 Oracle Corporation
+ * Copyright (C) 2010-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -20,6 +20,6 @@
 
 /* Qt includes: */
+#include <QList>
 #include <QObject>
-#include <QList>
 
 /* COM includes: */
@@ -36,4 +36,7 @@
 
 /* Forward declarations: */
+class QPoint;
+class QSize;
+class QString;
 class UIMainEventListeningThread;
 class CEventListener;
@@ -55,5 +58,5 @@
 
 /** Main event listener. */
-class UIMainEventListener: public QObject
+class UIMainEventListener : public QObject
 {
     Q_OBJECT;
@@ -61,87 +64,102 @@
 signals:
 
-    /** Notifies about the VBoxSVC become @a fAvailable. */
-    void sigVBoxSVCAvailabilityChange(bool fAvailable);
+    /** @name VirtualBoxClient related signals
+      * @{ */
+        /** Notifies about the VBoxSVC become @a fAvailable. */
+        void sigVBoxSVCAvailabilityChange(bool fAvailable);
+    /** @} */
 
-    /** Notifies about @a state change event for the machine with @a strId. */
-    void sigMachineStateChange(QString strId, KMachineState state);
-    /** Notifies about data change event for the machine with @a strId. */
-    void sigMachineDataChange(QString strId);
-    /** Notifies about machine with @a strId was @a fRegistered. */
-    void sigMachineRegistered(QString strId, bool fRegistered);
-    /** Notifies about @a state change event for the session of the machine with @a strId. */
-    void sigSessionStateChange(QString strId, KSessionState state);
-    /** Notifies about snapshot with @a strSnapshotId was taken for the machine with @a strId. */
-    void sigSnapshotTake(QString strId, QString strSnapshotId);
-    /** Notifies about snapshot with @a strSnapshotId was deleted for the machine with @a strId. */
-    void sigSnapshotDelete(QString strId, QString strSnapshotId);
-    /** Notifies about snapshot with @a strSnapshotId was changed for the machine with @a strId. */
-    void sigSnapshotChange(QString strId, QString strSnapshotId);
-    /** Notifies about snapshot with @a strSnapshotId was restored for the machine with @a strId. */
-    void sigSnapshotRestore(QString strId, QString strSnapshotId);
+    /** @name VirtualBox related signals
+      * @{ */
+        /** Notifies about @a state change event for the machine with @a strId. */
+        void sigMachineStateChange(QString strId, KMachineState state);
+        /** Notifies about data change event for the machine with @a strId. */
+        void sigMachineDataChange(QString strId);
+        /** Notifies about machine with @a strId was @a fRegistered. */
+        void sigMachineRegistered(QString strId, bool fRegistered);
+        /** Notifies about @a state change event for the session of the machine with @a strId. */
+        void sigSessionStateChange(QString strId, KSessionState state);
+        /** Notifies about snapshot with @a strSnapshotId was taken for the machine with @a strId. */
+        void sigSnapshotTake(QString strId, QString strSnapshotId);
+        /** Notifies about snapshot with @a strSnapshotId was deleted for the machine with @a strId. */
+        void sigSnapshotDelete(QString strId, QString strSnapshotId);
+        /** Notifies about snapshot with @a strSnapshotId was changed for the machine with @a strId. */
+        void sigSnapshotChange(QString strId, QString strSnapshotId);
+        /** Notifies about snapshot with @a strSnapshotId was restored for the machine with @a strId. */
+        void sigSnapshotRestore(QString strId, QString strSnapshotId);
+    /** @} */
 
-    /** Notifies about extra-data of the machine with @a strId can be changed for the key @a strKey to value @a strValue. */
-    void sigExtraDataCanChange(QString strId, QString strKey, QString strValue, bool &fVeto, QString &strVetoReason); /* use Qt::DirectConnection */
-    /** Notifies about extra-data of the machine with @a strId changed for the key @a strKey to value @a strValue. */
-    void sigExtraDataChange(QString strId, QString strKey, QString strValue);
+    /** @name VirtualBox Extra-data related signals
+      * @{ */
+        /** Notifies about extra-data of the machine with @a strId can be changed for the key @a strKey to value @a strValue. */
+        void sigExtraDataCanChange(QString strId, QString strKey, QString strValue, bool &fVeto, QString &strVetoReason); /* use Qt::DirectConnection */
+        /** Notifies about extra-data of the machine with @a strId changed for the key @a strKey to value @a strValue. */
+        void sigExtraDataChange(QString strId, QString strKey, QString strValue);
+    /** @} */
 
-    /** Notifies about mouse pointer become @a fVisible and his shape changed to @a fAlpha, @a hotCorner, @a size and @a shape. */
-    void sigMousePointerShapeChange(bool fVisible, bool fAlpha, QPoint hotCorner, QSize size, QVector<uint8_t> shape);
-    /** Notifies about mouse capability change to @a fSupportsAbsolute, @a fSupportsRelative, @a fSupportsMultiTouch and @a fNeedsHostCursor. */
-    void sigMouseCapabilityChange(bool fSupportsAbsolute, bool fSupportsRelative, bool fSupportsMultiTouch, bool fNeedsHostCursor);
-    /** Notifies about guest request to change the cursor position to @a uX * @a uY.
-      * @param  fContainsData  Brings whether the @a uX and @a uY values are valid and could be used by the GUI now. */
-    void sigCursorPositionChange(bool fContainsData, unsigned long uX, unsigned long uY);
-    /** Notifies about keyboard LEDs change for @a fNumLock, @a fCapsLock and @a fScrollLock. */
-    void sigKeyboardLedsChangeEvent(bool fNumLock, bool fCapsLock, bool fScrollLock);
-    /** Notifies about machine @a state change. */
-    void sigStateChange(KMachineState state);
-    /** Notifies about guest additions state change. */
-    void sigAdditionsChange();
-    /** Notifies about network @a adapter state change. */
-    void sigNetworkAdapterChange(CNetworkAdapter adapter);
-    /** Notifies about storage device change for @a attachment, which was @a fRemoved and it was @a fSilent for guest. */
-    void sigStorageDeviceChange(CMediumAttachment attachment, bool fRemoved, bool fSilent);
-    /** Notifies about storage medium @a attachment state change. */
-    void sigMediumChange(CMediumAttachment attachment);
-    /** Notifies about VRDE device state change. */
-    void sigVRDEChange();
-    /** Notifies about Video Capture device state change. */
-    void sigVideoCaptureChange();
-    /** Notifies about USB controller state change. */
-    void sigUSBControllerChange();
-    /** Notifies about USB @a device state change to @a fAttached, holding additional @a error information. */
-    void sigUSBDeviceStateChange(CUSBDevice device, bool fAttached, CVirtualBoxErrorInfo error);
-    /** Notifies about shared folder state change. */
-    void sigSharedFolderChange();
-    /** Notifies about CPU execution-cap change. */
-    void sigCPUExecutionCapChange();
-    /** Notifies about guest-screen configuration change of @a type for @a uScreenId with @a screenGeo. */
-    void sigGuestMonitorChange(KGuestMonitorChangedEventType changeType, ulong uScreenId, QRect screenGeo);
-    /** Notifies about Runtime error with @a strErrorId which is @a fFatal and have @a strMessage. */
-    void sigRuntimeError(bool fFatal, QString strErrorId, QString strMessage);
-    /** Notifies about VM window can be shown, allowing to prevent it by @a fVeto with @a strReason. */
-    void sigCanShowWindow(bool &fVeto, QString &strReason); /* use Qt::DirectConnection */
-    /** Notifies about VM window with specified @a winId should be shown. */
-    void sigShowWindow(qint64 &winId); /* use Qt::DirectConnection */
-    /** Notifies about audio adapter state change. */
-    void sigAudioAdapterChange();
+    /** @name Console related signals
+      * @{ */
+        /** Notifies about mouse pointer become @a fVisible and his shape changed to @a fAlpha, @a hotCorner, @a size and @a shape. */
+        void sigMousePointerShapeChange(bool fVisible, bool fAlpha, QPoint hotCorner, QSize size, QVector<uint8_t> shape);
+        /** Notifies about mouse capability change to @a fSupportsAbsolute, @a fSupportsRelative, @a fSupportsMultiTouch and @a fNeedsHostCursor. */
+        void sigMouseCapabilityChange(bool fSupportsAbsolute, bool fSupportsRelative, bool fSupportsMultiTouch, bool fNeedsHostCursor);
+        /** Notifies about guest request to change the cursor position to @a uX * @a uY.
+          * @param  fContainsData  Brings whether the @a uX and @a uY values are valid and could be used by the GUI now. */
+        void sigCursorPositionChange(bool fContainsData, unsigned long uX, unsigned long uY);
+        /** Notifies about keyboard LEDs change for @a fNumLock, @a fCapsLock and @a fScrollLock. */
+        void sigKeyboardLedsChangeEvent(bool fNumLock, bool fCapsLock, bool fScrollLock);
+        /** Notifies about machine @a state change. */
+        void sigStateChange(KMachineState state);
+        /** Notifies about guest additions state change. */
+        void sigAdditionsChange();
+        /** Notifies about network @a adapter state change. */
+        void sigNetworkAdapterChange(CNetworkAdapter comAdapter);
+        /** Notifies about storage device change for @a attachment, which was @a fRemoved and it was @a fSilent for guest. */
+        void sigStorageDeviceChange(CMediumAttachment comAttachment, bool fRemoved, bool fSilent);
+        /** Notifies about storage medium @a attachment state change. */
+        void sigMediumChange(CMediumAttachment comAttachment);
+        /** Notifies about VRDE device state change. */
+        void sigVRDEChange();
+        /** Notifies about Video Capture device state change. */
+        void sigVideoCaptureChange();
+        /** Notifies about USB controller state change. */
+        void sigUSBControllerChange();
+        /** Notifies about USB @a device state change to @a fAttached, holding additional @a error information. */
+        void sigUSBDeviceStateChange(CUSBDevice comDevice, bool fAttached, CVirtualBoxErrorInfo comError);
+        /** Notifies about shared folder state change. */
+        void sigSharedFolderChange();
+        /** Notifies about CPU execution-cap change. */
+        void sigCPUExecutionCapChange();
+        /** Notifies about guest-screen configuration change of @a type for @a uScreenId with @a screenGeo. */
+        void sigGuestMonitorChange(KGuestMonitorChangedEventType changeType, ulong uScreenId, QRect screenGeo);
+        /** Notifies about Runtime error with @a strErrorId which is @a fFatal and have @a strMessage. */
+        void sigRuntimeError(bool fFatal, QString strErrorId, QString strMessage);
+        /** Notifies about VM window can be shown, allowing to prevent it by @a fVeto with @a strReason. */
+        void sigCanShowWindow(bool &fVeto, QString &strReason); /* use Qt::DirectConnection */
+        /** Notifies about VM window with specified @a winId should be shown. */
+        void sigShowWindow(qint64 &winId); /* use Qt::DirectConnection */
+        /** Notifies about audio adapter state change. */
+        void sigAudioAdapterChange();
+    /** @} */
 
-    /** Notifies about @a iPercent change for progress with @a strProgressId. */
-    void sigProgressPercentageChange(QString strProgressId, int iPercent);
-    /** Notifies about task complete for progress with @a strProgressId. */
-    void sigProgressTaskComplete(QString strProgressId);
+    /** @name Progress related signals
+      * @{ */
+        /** Notifies about @a iPercent change for progress with @a strProgressId. */
+        void sigProgressPercentageChange(QString strProgressId, int iPercent);
+        /** Notifies about task complete for progress with @a strProgressId. */
+        void sigProgressTaskComplete(QString strProgressId);
+    /** @} */
 
     /** @name Guest Session related signals
       * @{ */
         /** Notifies about guest session (un)registered event @a is the (un)registed guest session. */
-        void sigGuestSessionRegistered(CGuestSession guestSession);
-        void sigGuestSessionUnregistered(CGuestSession guestSession);
+        void sigGuestSessionRegistered(CGuestSession comGuestSession);
+        void sigGuestSessionUnregistered(CGuestSession comGuestSession);
 
         /** Notifies about guest process (un)registered event @a is the (un)registed guest process. */
-        void sigGuestProcessRegistered(CGuestProcess guestProcess);
-        void sigGuestProcessUnregistered(CGuestProcess guestProcess);
-        void sigGuestSessionStatedChanged(const CGuestSessionStateChangedEvent &cEvent);
-        void sigGuestProcessStateChanged(const CGuestProcessStateChangedEvent &cEvent);
+        void sigGuestProcessRegistered(CGuestProcess comGuestProcess);
+        void sigGuestProcessUnregistered(CGuestProcess comGuestProcess);
+        void sigGuestSessionStatedChanged(const CGuestSessionStateChangedEvent &comEvent);
+        void sigGuestProcessStateChanged(const CGuestProcessStateChangedEvent &comEvent);
     /** @} */
 
@@ -157,5 +175,5 @@
 
     /** Registers event @a source for passive event @a listener. */
-    void registerSource(const CEventSource &source, const CEventListener &listener);
+    void registerSource(const CEventSource &comSource, const CEventListener &comListener);
     /** Unregisters event sources. */
     void unregisterSources();
@@ -168,6 +186,7 @@
 };
 
-/* Wrap the IListener interface around our implementation class. */
+/** Wraps the IListener interface around our implementation class. */
 typedef ListenerImpl<UIMainEventListener, QObject*> UIMainEventListenerImpl;
 
 #endif /* !___UIMainEventListener_h___ */
+